<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIdentifierVehicleExtra ArrayType
 * @subpackage Arrays
 */
class ArrayOfIdentifierVehicleExtra extends AbstractStructArrayBase
{
    /**
     * The IdentifierVehicleExtra
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\IdentifierVehicleExtra[]
     */
    public $IdentifierVehicleExtra;
    /**
     * Constructor method for ArrayOfIdentifierVehicleExtra
     * @uses ArrayOfIdentifierVehicleExtra::setIdentifierVehicleExtra()
     * @param \StructType\IdentifierVehicleExtra[] $identifierVehicleExtra
     */
    public function __construct(array $identifierVehicleExtra = array())
    {
        $this
            ->setIdentifierVehicleExtra($identifierVehicleExtra);
    }
    /**
     * Get IdentifierVehicleExtra value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\IdentifierVehicleExtra[]|null
     */
    public function getIdentifierVehicleExtra()
    {
        return isset($this->IdentifierVehicleExtra) ? $this->IdentifierVehicleExtra : null;
    }
    /**
     * This method is responsible for validating the values passed to the setIdentifierVehicleExtra method
     * This method is willingly generated in order to preserve the one-line inline validation within the setIdentifierVehicleExtra method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateIdentifierVehicleExtraForArrayConstraintsFromSetIdentifierVehicleExtra(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfIdentifierVehicleExtraIdentifierVehicleExtraItem) {
            // validation for constraint: itemType
            if (!$arrayOfIdentifierVehicleExtraIdentifierVehicleExtraItem instanceof \StructType\IdentifierVehicleExtra) {
                $invalidValues[] = is_object($arrayOfIdentifierVehicleExtraIdentifierVehicleExtraItem) ? get_class($arrayOfIdentifierVehicleExtraIdentifierVehicleExtraItem) : sprintf('%s(%s)', gettype($arrayOfIdentifierVehicleExtraIdentifierVehicleExtraItem), var_export($arrayOfIdentifierVehicleExtraIdentifierVehicleExtraItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The IdentifierVehicleExtra property can only contain items of type \StructType\IdentifierVehicleExtra, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set IdentifierVehicleExtra value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleExtra[] $identifierVehicleExtra
     * @return \ArrayType\ArrayOfIdentifierVehicleExtra
     */
    public function setIdentifierVehicleExtra(array $identifierVehicleExtra = array())
    {
        // validation for constraint: array
        if ('' !== ($identifierVehicleExtraArrayErrorMessage = self::validateIdentifierVehicleExtraForArrayConstraintsFromSetIdentifierVehicleExtra($identifierVehicleExtra))) {
            throw new \InvalidArgumentException($identifierVehicleExtraArrayErrorMessage, __LINE__);
        }
        if (is_null($identifierVehicleExtra) || (is_array($identifierVehicleExtra) && empty($identifierVehicleExtra))) {
            unset($this->IdentifierVehicleExtra);
        } else {
            $this->IdentifierVehicleExtra = $identifierVehicleExtra;
        }
        return $this;
    }
    /**
     * Add item to IdentifierVehicleExtra value
     * @throws \InvalidArgumentException
     * @param \StructType\IdentifierVehicleExtra $item
     * @return \ArrayType\ArrayOfIdentifierVehicleExtra
     */
    public function addToIdentifierVehicleExtra(\StructType\IdentifierVehicleExtra $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\IdentifierVehicleExtra) {
            throw new \InvalidArgumentException(sprintf('The IdentifierVehicleExtra property can only contain items of type \StructType\IdentifierVehicleExtra, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->IdentifierVehicleExtra[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\IdentifierVehicleExtra|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\IdentifierVehicleExtra|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\IdentifierVehicleExtra|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\IdentifierVehicleExtra|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\IdentifierVehicleExtra|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string IdentifierVehicleExtra
     */
    public function getAttributeName()
    {
        return 'IdentifierVehicleExtra';
    }
}
